/**
 * This class implements a simple cdata generator that produces random
 * almost-readable text according to the grammar specified by the
 * XMark benchmark
 *
 * This code is provided as part of ToXgene - (c) 2001 University of Toronto
 * and IBM Corporation.
 *
 * @author Denilson Barbosa
 * @version 1.0
 */

package util.cdata.xmark;

import genes.literals.Cdata;
import random.ToxExponential;

public class Text implements Cdata{
	private static ToxExponential pickWord;
	private static String result;

	/**
	 * Constructor. See @see Names.java
	 *
	 * Note: cdata generated by this class uses the words stored by the
	 * @see Names class.
	 */
	public Text(){
		pickWord = new ToxExponential(0,Names.len-1,3400);
		Names.init(); //this method loads the names into Names.data
	}

	/**
	 * specifies a random number generator
	 */
	public void setRandomSeed(int seed){
		//we don't use the random seed generator because ToxExponential
		//does it automatically
	}
	
	/**
	 * Generates random text that is at most @param length characters
	 * long if @param lenght is different than -1.
	 */
	public String getCdata(int length){
		if (length == -1){
			// this is dangerous: very long strings can be generated this way
			length = (int) (1024.0 * Math.random());
		}

		result = new String();
		while (result.length()<length){
			result += Names.data[(int)pickWord.nextInt()] + " ";
		}
		return result.substring(0,length);
  }	
}
